module acc_74281 # (
	parameter ALU_WIDTH = 4
) (
		  output [ALU_WIDTH-1:0] B    // DATA OUT
		, input  [ALU_WIDTH-1:0] F    // DATA IN

		, input  [1:0] RS   // Reg. Select
		, input   RC         // Reg. Control
		, input   CP         // Clock 
		, input   SI0        // RI/LO
		, output  SO0        // RI/LO
		, input   SI3        // LI/RO
		, output  SO3        // LI/RO
		);

    reg [ALU_WIDTH-1:0] acc;

    assign B = acc; 
    assign SO0 =  F[0];
    assign SO3 = RC ? F[ALU_WIDTH-2] : F[ALU_WIDTH-1];

    always @(posedge CP)
    begin
	acc  <=   (RS == 0) ? F
		: (RS == 1) ? { ( RC ? acc[ALU_WIDTH-1] : F[ALU_WIDTH-2] )
				, F[ALU_WIDTH-3:0] , SI0 }
		: (RS == 2) ? { ( RC ? acc[ALU_WIDTH-1] : SI3 )
				, ( RC ? SI3 : F[ALU_WIDTH-1] )
				, F[ALU_WIDTH-2:1] }
		: acc;
    end

    initial
    begin
	acc  <= 0;
    end

endmodule
