#include <stdio.h>

alu_test_logic(int S, int C_in, int Z_in, int A, int B, int mode) {
	int ALU_OUT,F;
	int V_in = 0;
	int C_out, Z_out, V_out;
	int F_7_, A_7_, B_7_;
	S &= 0x7;
	C_in &= 1;
	Z_in &= 1;
	A &= 0xff;
	B &= 0xff;

        ALU_OUT = ((S == 0) | (S == 1)) ?  A  + B + (C_in & (S & 1))
                : ((S == 2) | (S == 3)) ? A - B - (C_in & ~(S & 1))
		: (S == 4) ? (C_in << 8) | (A & B)
		: (S == 5) ? (C_in << 8) | (A ^ B)
		: (S == 6) ? (C_in << 8) | (A | B)
		: (C_in << 8);

	F = ALU_OUT & 0xff;
	C_out = (ALU_OUT >> 8) & 1;

	Z_out = (S == 7) & Z_in
                  | ( (S == 2) & Z_in | ~((S == 2)|(S == 7)) ) & (F == 0) ;

	F_7_ = (F >> 7) & 1;
	A_7_ = (A >> 7) & 1;
	B_7_ = (B >> 7) & 1;

	V_out = ((S == 0)|(S == 1)) & (F_7_ & ~A_7_ & ~B_7_
                                | ~F_7_ &  A_7_ &  B_7_ )
              | ((S == 2)|(S == 3))  & (   F_7_ & ~A_7_ &  B_7_
                                | ~F_7_ &  A_7_ & ~B_7_ )
              | (S == 7) & V_in ;
              //  ((S == 4)|(S == 5)|(S == 6)) ? 0
	if (mode == 0) {
		return F & 1;
	}
	if (mode == 1) {
#if 0
		int r;
		F_7_ = (F >> 0) & 1;
		A_7_ = (A >> 0) & 1;
		B_7_ = (B >> 0) & 1;

		r = ((S == 0) | (S == 1)) & ( 
				  ~F_7_ & A_7_ 
				| ~F_7_ & B_7_
				|  A_7_  & B_7_ )
		       | ((S == 2) | (S == 3)) & (
				   F_7_ & ~A_7_ 
				|  F_7_ &  B_7_
				| ~A_7_  &  B_7_ );
		return r & 1;
#endif
		return (F >> 1) & 1;
	}
	if (mode == 2) {
		int r;
		F_7_ = (F >> 0) & 1;
		A_7_ = (A >> 0) & 1;
		B_7_ = (B >> 0) & 1;

		r     = ((S == 0)|(S == 1)) & (F_7_ & ~A_7_ & ~B_7_
					| ~F_7_ &  A_7_ &  B_7_ )
		      | ((S == 2)|(S == 3))  & (   F_7_ & ~A_7_ &  B_7_
					| ~F_7_ &  A_7_ & ~B_7_ )
		      | (S == 7) & V_in ;
		return r;
	}
	if (mode == 13) {
		return ((F&1) == 0);
	}
	if (mode == 3) {
		int r,ret;
		int ss;
		if (ss == 0) ss = 1;
		if (ss == 3) ss = 2;
		ret = alu_test_logic(ss,C_in,Z_in,A,B,  13) & 1;
		r     = (S == 7) ? Z_in
                  : ( (S == 2) & Z_in | ~((S == 2)|(S == 7)) ) & ret;
		return r;
	}
	if (mode == 4) {
		int r;
		r     = (S == 7) & Z_in
                  | ( (S == 2) & Z_in | ~((S == 2)|(S == 7)) ) & ((F&3) == 0);
		return r;
	}
	if (mode == 10) {
		int r,ret;
		ret = 0;
		ret = alu_test_logic(S,C_in,Z_in,A,B,  0) & 1;
		  r = alu_test_logic(S,C_in,Z_in,A,B,  1) & 1;
		ret |= (r << 1);
		  r = alu_test_logic(S,C_in,Z_in,A,B,  2) & 1;
		ret |= (r << 2);
		return ret;
	}
	return F;
}

main() {
	int s,c,z,a,b;
	int i,r;


//	r = alu_test_logic(3,0,0,60,64, -1);
//printf("60 - 64 = %d(0x%02x)\n",(char)r,r);
	z = 0;
	/* F[0] = { S[1:0] , C_in , A[0], B[0] } */
	for (i=0; i<32; i++) {
		s = (i >> 3) & 0x7;
		c = (i >> 2) & 0x1;
		a = (i >> 1) & 0x1;
		b = (i >> 0) & 0x1;
		r = alu_test_logic(s,c,z,a,b, 0);
#ifdef BIT_OUT
		printf("%d", r);
#elif defined(INIT_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\tFF[%2d] <= 1\'b%d ;", i,r);
#elif defined(CASE_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\t%2d: FF = 1\'b%d ;", i,r);
#else
		printf("\t\t: (FF == %2d)  ? 1\'b%d\n", i,r);
#endif
	}
	printf("\n");

	/* C[0+1] = { S , C_in , A[0], B[0] } */
	for (i=0; i<32; i++) {
		s = (i >> 3) & 0x7;
		c = (i >> 2) & 0x1;
		a = (i >> 1) & 0x1;
		b = (i >> 0) & 0x1;
		r = alu_test_logic(s,c,z,a,b, 1);
#ifdef BIT_OUT
		printf("%d", r);
#elif defined(INIT_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\tCC[%2d] <= 1\'b%d ;", i,r);
#elif defined(CASE_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\t%2d: CC = 1\'b%d ;", i,r);
#else
		printf("\t\t: (CC == %2d)  ? 1\'b%d\n", i,r);
#endif
	}
	printf("\n");
	/* OV[0+1] = { S , C_in , A[0], B[0] } */
	for (i=0; i<32; i++) {
		s = (i >> 3) & 0x7;
		c = (i >> 2) & 0x1;
		a = (i >> 1) & 0x1;
		b = (i >> 0) & 0x1;
		r = alu_test_logic(s,c,z,a,b, 2);
#ifdef BIT_OUT
		printf("%d", r);
#elif defined(INIT_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\tOO[%2d] <= 1\'b%d ;", i,r);
#elif defined(CASE_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\t%2d: OO = 1\'b%d ;", i,r);
#else
		printf("\t\t: (OO == %2d)  ? 1\'b%d\n", i,r);
#endif
	}
	printf("\n");
	/* Z = { Z_in, S[1:0] , C_in , A[0], B[0] } */
	for (i=0; i<64; i++) {
		z = (i >> 5) & 0x1;
		s = (i >> 3) & 0x3;
		c = (i >> 2) & 0x1;
		a = (i >> 1) & 0x1;
		b = (i >> 0) & 0x1;
		r = alu_test_logic(s,c,z,a,b, 3);
#ifdef BIT_OUT
		printf("%d", r);
#elif defined(INIT_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\tSZ[%2d] <= 1\'b%d ;", i,r);
#elif defined(CASE_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\t%2d: SZ = 1\'b%d ;", i,r);
#else
		printf("\t\t: (zz == %2d)  ? 1\'b%d\n", i,r);
#endif
	}
	printf("\n");
	/* Z = { Z_in, S[1:0] , C_in , A[1:0], B[1:0] } */
	for (i=0; i<256; i++) {
		z = (i >> 7) & 0x1;
		s = (i >> 5) & 0x3;
		c = (i >> 4) & 0x1;
		a = (i >> 2) & 0x1;
		b = (i >> 0) & 0x1;
		r = alu_test_logic(s,c,z,a,b, 4);
		if ((i % 64) == 0) printf("\n");
#ifdef BIT_OUT
		printf("%d", r);
#elif defined(INIT_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\tZZ[%2d] <= 1\'b%d ;", i,r);
#elif defined(CASE_OUT)
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\t%3d: ZZ = 1\'b%d ;", i,r);
#else
		printf("\t\t: (ZZ == %2d)  ? 1\'b%d\n", i,r);
#endif
	}
	printf("\n");
#ifdef INIT_OUT
	z = 0;
	/* F[0] = { S[1:0] , C_in , A[0], B[0] } */
	for (i=0; i<32; i++) {
		s = (i >> 3) & 0x7;
		c = (i >> 2) & 0x1;
		a = (i >> 1) & 0x1;
		b = (i >> 0) & 0x1;
		r = alu_test_logic(s,c,z,a,b, 10);
		if ((i % 2) == 0) printf("\n\t\t");
		printf("\tLUT[%2d] <= 3\'h%x ;", i,r);
	}
	printf("\n");
#endif
}
