#include <stdio.h>

int FF[32];
int CC[32];
int OO[32];
int SZ[64];
int ZZ[256];
int LUT[32];

static void init_lut();

#define mkidx(s, c, a, b, i) \
	( (s << 3) | (((c>>i)&1)<< 2) | (((a>>i)&1) << 1) | ((b>>i) & 1))

#define mkidx_sz(z, s, c, a, b, i) \
	( (z << 5) | (s << 3) | (((c>>i)&1)<< 2) \
	  | (((a>>i)&1) << 1) | ((b>>i) & 1))

alu_test(int s, int ci, int zi, int a, int b) {
	int fo;
	int co, zo;
	int c,ov;
	int vi = 0;
	int idx;
	int idxz;
	int i;
	int ss;

	s &= 0x7;
	ci &= 1;
	zi &= 1;
	a &= 0xff;
	b &= 0xff;
	ov = 0;

	if ( (s == 0) | (s == 1)  | (s == 2)  | (s == 3)) {
		fo = 0;
		c = ci;
		ss = s;
		for (i=0; i<8; i++) {
			idx = mkidx(ss, c, a, b, i);
			idxz = mkidx_sz(zi, s, c, a, b, i);
#if 0
printf("i=%d idx = %d FF = %d -- %d\n",i,idx, FF[idx]
	,((((a>>i)&1) << 1) | ((b>>i) & 1)) );
#endif
#if ( TEST == 1) 
printf("i=%d idx = %d FF = %d -- %d\n",i,idx, FF[idx]
	,((((a>>i)&1) << 1) | ((b>>i) & 1)) );
printf("   FF %d CC %d OO %d\n", FF[idx], CC[idx], OO[idx]);
#endif
			fo |= (FF[idx] << (i));
			c  |= (CC[idx] << (i+1));
			if (i==7) {
				ov = OO[idx];
				zo = SZ[idxz] & ((fo & 0x7f) == 0);
			}
			if (ss == 0) ss = 1;
			if (ss == 3) ss = 2;
		}
		co = c >> 8;
	} else if (s == 4) {
		fo = a & b;
		co = ci;
		ov = 0;
		zo = (fo == 0);
	} else if (s == 5) {
		fo = a ^ b;
		co = ci;
		ov = 0;
		zo = (fo == 0);
	} else if (s == 6) {
		fo = a | b;
		co = ci;
		ov = 0;
		zo = (fo == 0);
	} else if (s == 7) {
		fo = b;
		co = ci;
		ov = vi;
		zo = zi;
	}

	printf("s %d(%s) ci %d zi %d a 0x%x b 0x%x =>  ov %d co %d zo %d fo 0x%x\n"
		, s
		, (s == 0)?"ADD"
		 :(s == 1)?"ADC"
		 :(s == 2)?"SBC"
		 :(s == 3)?"SUB"
		 :(s == 4)?"AND"
		 :(s == 5)?"XOR"
		 :(s == 6)?"OR "
		 : "MOV"
		, ci, zi, a, b, ov, co, zo, fo);
}

alu_test_logic(int S, int C_in, int Z_in, int A, int B) {
	int ALU_OUT,F;
	int V_in = 0;
	int C_out, Z_out, V_out;
	int F_7_, A_7_, B_7_;
	S &= 0x7;
	C_in &= 1;
	Z_in &= 1;
	A &= 0xff;
	B &= 0xff;

        ALU_OUT = ((S == 0) | (S == 1)) ?  A  + B + (C_in & (S & 1))
                : ((S == 2) | (S == 3)) ? A - B - (C_in & ~(S & 1))
		: (S == 4) ? (C_in << 8) | (A & B)
		: (S == 5) ? (C_in << 8) | (A ^ B)
		: (S == 6) ? (C_in << 8) | (A | B)
		: (C_in << 8) | B;

	F = ALU_OUT & 0xff;
	C_out = (ALU_OUT >> 8) & 1;

	Z_out = (S == 7) & Z_in
                  | ( (S == 2) & Z_in | ~((S == 2)|(S == 7)) ) & (F == 0) ;

	F_7_ = (F >> 7) & 1;
	A_7_ = (A >> 7) & 1;
	B_7_ = (B >> 7) & 1;

	V_out = ((S == 0)|(S == 1)) & (F_7_ & ~A_7_ & ~B_7_
                                | ~F_7_ &  A_7_ &  B_7_ )
              | ((S == 2)|(S == 3))  & (   F_7_ & ~A_7_ &  B_7_
                                | ~F_7_ &  A_7_ & ~B_7_ )
              | (S == 7) & V_in ;
              //  ((S == 4)|(S == 5)|(S == 6)) ? 0
	printf("s %d(%s) ci %d zi %d a 0x%x b 0x%x =>  ov %d co %d zo %d fo 0x%x\n"
		, S
		, (S == 0)?"ADD"
		 :(S == 1)?"ADC"
		 :(S == 2)?"SBC"
		 :(S == 3)?"SUB"
		 :(S == 4)?"AND"
		 :(S == 5)?"XOR"
		 :(S == 6)?"OR "
		 : "MOV"
		, C_in, Z_in, A, B, V_out, C_out, Z_out, F);
	return F;
}

main() {
	int s,c,z,v,a,b;
	char buf[256];
	init_lut();

#if 0
	while (fgets(buf, 256, stdin)) {
		if (sscanf(buf, "%d %x %x %x\n",&s,&c,&a,&b) == 4) {
			alu_test(s, c, a, b);
		}
	}
#elif ( TEST == 1) 
//	alu_test_logic(0, 0, 0, 1, 1);
//	alu_test(0, 0, 0, 1, 1);
//	alu_test_logic(0, 0, 0, 1, 3);
//	alu_test(0, 0, 0, 1, 3);
//	alu_test_logic(0, 0, 0, 1, 0x7f);
//	alu_test(0, 0, 0, 1, 0x7f);
//	alu_test_logic(0, 1, 0, 0, 1);
//	alu_test(0, 1, 0, 0, 1);
//	alu_test_logic(3, 0, 0, 0, 0);
//	alu_test(3, 0, 0, 0, 0);
	alu_test_logic(7, 0, 0, 0, 1);
	alu_test(7, 0, 0, 0, 1);
#else
	z = 0;
	for (s = 0; s < 8; s++) {
	    for (c=0; c<2; c++) {
		for (a=0; a<256; a++) {
		   for (b=0; b<256; b++) {
#if ( TEST == 2)
			alu_test_logic(s, c, z, a, b);
#else
			alu_test(s, c, z, a, b);
#endif
		   }
		}
	    }
	}
#endif
}

static void init_lut() {
		FF[ 0] = 0 ;	FF[ 1] = 1 ;
		FF[ 2] = 1 ;	FF[ 3] = 0 ;
		FF[ 4] = 0 ;	FF[ 5] = 1 ;
		FF[ 6] = 1 ;	FF[ 7] = 0 ;
		FF[ 8] = 0 ;	FF[ 9] = 1 ;
		FF[10] = 1 ;	FF[11] = 0 ;
		FF[12] = 1 ;	FF[13] = 0 ;
		FF[14] = 0 ;	FF[15] = 1 ;
		FF[16] = 0 ;	FF[17] = 1 ;
		FF[18] = 1 ;	FF[19] = 0 ;
		FF[20] = 1 ;	FF[21] = 0 ;
		FF[22] = 0 ;	FF[23] = 1 ;
		FF[24] = 0 ;	FF[25] = 1 ;
		FF[26] = 1 ;	FF[27] = 0 ;
		FF[28] = 0 ;	FF[29] = 1 ;
		FF[30] = 1 ;	FF[31] = 0 ;

		CC[ 0] = 0 ;	CC[ 1] = 0 ;
		CC[ 2] = 0 ;	CC[ 3] = 1 ;
		CC[ 4] = 0 ;	CC[ 5] = 0 ;
		CC[ 6] = 0 ;	CC[ 7] = 1 ;
		CC[ 8] = 0 ;	CC[ 9] = 0 ;
		CC[10] = 0 ;	CC[11] = 1 ;
		CC[12] = 0 ;	CC[13] = 1 ;
		CC[14] = 1 ;	CC[15] = 1 ;
		CC[16] = 0 ;	CC[17] = 1 ;
		CC[18] = 0 ;	CC[19] = 0 ;
		CC[20] = 1 ;	CC[21] = 1 ;
		CC[22] = 0 ;	CC[23] = 1 ;
		CC[24] = 0 ;	CC[25] = 1 ;
		CC[26] = 0 ;	CC[27] = 0 ;
		CC[28] = 0 ;	CC[29] = 1 ;
		CC[30] = 0 ;	CC[31] = 0 ;

		OO[ 0] = 0 ;	OO[ 1] = 0 ;
		OO[ 2] = 0 ;	OO[ 3] = 1 ;
		OO[ 4] = 0 ;	OO[ 5] = 0 ;
		OO[ 6] = 0 ;	OO[ 7] = 1 ;
		OO[ 8] = 0 ;	OO[ 9] = 0 ;
		OO[10] = 0 ;	OO[11] = 1 ;
		OO[12] = 1 ;	OO[13] = 0 ;
		OO[14] = 0 ;	OO[15] = 0 ;
		OO[16] = 0 ;	OO[17] = 1 ;
		OO[18] = 0 ;	OO[19] = 0 ;
		OO[20] = 0 ;	OO[21] = 0 ;
		OO[22] = 1 ;	OO[23] = 0 ;
		OO[24] = 0 ;	OO[25] = 1 ;
		OO[26] = 0 ;	OO[27] = 0 ;
		OO[28] = 0 ;	OO[29] = 1 ;
		OO[30] = 0 ;	OO[31] = 0 ;

		SZ[ 0] = 1 ;	SZ[ 1] = 0 ;
		SZ[ 2] = 0 ;	SZ[ 3] = 1 ;
		SZ[ 4] = 0 ;	SZ[ 5] = 1 ;
		SZ[ 6] = 1 ;	SZ[ 7] = 0 ;
		SZ[ 8] = 1 ;	SZ[ 9] = 0 ;
		SZ[10] = 0 ;	SZ[11] = 1 ;
		SZ[12] = 0 ;	SZ[13] = 1 ;
		SZ[14] = 1 ;	SZ[15] = 0 ;
		SZ[16] = 0 ;	SZ[17] = 0 ;
		SZ[18] = 0 ;	SZ[19] = 0 ;
		SZ[20] = 0 ;	SZ[21] = 0 ;
		SZ[22] = 0 ;	SZ[23] = 0 ;
		SZ[24] = 1 ;	SZ[25] = 0 ;
		SZ[26] = 0 ;	SZ[27] = 1 ;
		SZ[28] = 0 ;	SZ[29] = 1 ;
		SZ[30] = 1 ;	SZ[31] = 0 ;
		SZ[32] = 1 ;	SZ[33] = 0 ;
		SZ[34] = 0 ;	SZ[35] = 1 ;
		SZ[36] = 0 ;	SZ[37] = 1 ;
		SZ[38] = 1 ;	SZ[39] = 0 ;
		SZ[40] = 1 ;	SZ[41] = 0 ;
		SZ[42] = 0 ;	SZ[43] = 1 ;
		SZ[44] = 0 ;	SZ[45] = 1 ;
		SZ[46] = 1 ;	SZ[47] = 0 ;
		SZ[48] = 1 ;	SZ[49] = 0 ;
		SZ[50] = 0 ;	SZ[51] = 1 ;
		SZ[52] = 0 ;	SZ[53] = 1 ;
		SZ[54] = 1 ;	SZ[55] = 0 ;
		SZ[56] = 1 ;	SZ[57] = 0 ;
		SZ[58] = 0 ;	SZ[59] = 1 ;
		SZ[60] = 0 ;	SZ[61] = 1 ;
		SZ[62] = 1 ;	SZ[63] = 0 ;


		ZZ[ 0] = 1 ;	ZZ[ 1] = 0 ;
		ZZ[ 2] = 1 ;	ZZ[ 3] = 0 ;
		ZZ[ 4] = 0 ;	ZZ[ 5] = 0 ;
		ZZ[ 6] = 0 ;	ZZ[ 7] = 0 ;
		ZZ[ 8] = 1 ;	ZZ[ 9] = 0 ;
		ZZ[10] = 1 ;	ZZ[11] = 0 ;
		ZZ[12] = 0 ;	ZZ[13] = 0 ;
		ZZ[14] = 0 ;	ZZ[15] = 0 ;
		ZZ[16] = 1 ;	ZZ[17] = 0 ;
		ZZ[18] = 1 ;	ZZ[19] = 0 ;
		ZZ[20] = 0 ;	ZZ[21] = 0 ;
		ZZ[22] = 0 ;	ZZ[23] = 0 ;
		ZZ[24] = 1 ;	ZZ[25] = 0 ;
		ZZ[26] = 1 ;	ZZ[27] = 0 ;
		ZZ[28] = 0 ;	ZZ[29] = 0 ;
		ZZ[30] = 0 ;	ZZ[31] = 0 ;
		ZZ[32] = 1 ;	ZZ[33] = 0 ;
		ZZ[34] = 1 ;	ZZ[35] = 0 ;
		ZZ[36] = 0 ;	ZZ[37] = 0 ;
		ZZ[38] = 0 ;	ZZ[39] = 0 ;
		ZZ[40] = 1 ;	ZZ[41] = 0 ;
		ZZ[42] = 1 ;	ZZ[43] = 0 ;
		ZZ[44] = 0 ;	ZZ[45] = 0 ;
		ZZ[46] = 0 ;	ZZ[47] = 0 ;
		ZZ[48] = 0 ;	ZZ[49] = 0 ;
		ZZ[50] = 0 ;	ZZ[51] = 0 ;
		ZZ[52] = 0 ;	ZZ[53] = 0 ;
		ZZ[54] = 0 ;	ZZ[55] = 0 ;
		ZZ[56] = 0 ;	ZZ[57] = 0 ;
		ZZ[58] = 0 ;	ZZ[59] = 0 ;
		ZZ[60] = 0 ;	ZZ[61] = 0 ;
		ZZ[62] = 0 ;	ZZ[63] = 0 ;

		ZZ[64] = 0 ;	ZZ[65] = 0 ;
		ZZ[66] = 0 ;	ZZ[67] = 0 ;
		ZZ[68] = 0 ;	ZZ[69] = 0 ;
		ZZ[70] = 0 ;	ZZ[71] = 0 ;
		ZZ[72] = 0 ;	ZZ[73] = 0 ;
		ZZ[74] = 0 ;	ZZ[75] = 0 ;
		ZZ[76] = 0 ;	ZZ[77] = 0 ;
		ZZ[78] = 0 ;	ZZ[79] = 0 ;
		ZZ[80] = 0 ;	ZZ[81] = 0 ;
		ZZ[82] = 0 ;	ZZ[83] = 0 ;
		ZZ[84] = 0 ;	ZZ[85] = 0 ;
		ZZ[86] = 0 ;	ZZ[87] = 0 ;
		ZZ[88] = 0 ;	ZZ[89] = 0 ;
		ZZ[90] = 0 ;	ZZ[91] = 0 ;
		ZZ[92] = 0 ;	ZZ[93] = 0 ;
		ZZ[94] = 0 ;	ZZ[95] = 0 ;
		ZZ[96] = 1 ;	ZZ[97] = 0 ;
		ZZ[98] = 1 ;	ZZ[99] = 0 ;
		ZZ[100] = 0 ;	ZZ[101] = 1 ;
		ZZ[102] = 0 ;	ZZ[103] = 1 ;
		ZZ[104] = 1 ;	ZZ[105] = 0 ;
		ZZ[106] = 1 ;	ZZ[107] = 0 ;
		ZZ[108] = 0 ;	ZZ[109] = 1 ;
		ZZ[110] = 0 ;	ZZ[111] = 1 ;
		ZZ[112] = 1 ;	ZZ[113] = 0 ;
		ZZ[114] = 1 ;	ZZ[115] = 0 ;
		ZZ[116] = 0 ;	ZZ[117] = 1 ;
		ZZ[118] = 0 ;	ZZ[119] = 1 ;
		ZZ[120] = 1 ;	ZZ[121] = 0 ;
		ZZ[122] = 1 ;	ZZ[123] = 0 ;
		ZZ[124] = 0 ;	ZZ[125] = 1 ;
		ZZ[126] = 0 ;	ZZ[127] = 1 ;

		ZZ[128] = 1 ;	ZZ[129] = 0 ;
		ZZ[130] = 1 ;	ZZ[131] = 0 ;
		ZZ[132] = 0 ;	ZZ[133] = 0 ;
		ZZ[134] = 0 ;	ZZ[135] = 0 ;
		ZZ[136] = 1 ;	ZZ[137] = 0 ;
		ZZ[138] = 1 ;	ZZ[139] = 0 ;
		ZZ[140] = 0 ;	ZZ[141] = 0 ;
		ZZ[142] = 0 ;	ZZ[143] = 0 ;
		ZZ[144] = 1 ;	ZZ[145] = 0 ;
		ZZ[146] = 1 ;	ZZ[147] = 0 ;
		ZZ[148] = 0 ;	ZZ[149] = 0 ;
		ZZ[150] = 0 ;	ZZ[151] = 0 ;
		ZZ[152] = 1 ;	ZZ[153] = 0 ;
		ZZ[154] = 1 ;	ZZ[155] = 0 ;
		ZZ[156] = 0 ;	ZZ[157] = 0 ;
		ZZ[158] = 0 ;	ZZ[159] = 0 ;
		ZZ[160] = 1 ;	ZZ[161] = 0 ;
		ZZ[162] = 1 ;	ZZ[163] = 0 ;
		ZZ[164] = 0 ;	ZZ[165] = 0 ;
		ZZ[166] = 0 ;	ZZ[167] = 0 ;
		ZZ[168] = 1 ;	ZZ[169] = 0 ;
		ZZ[170] = 1 ;	ZZ[171] = 0 ;
		ZZ[172] = 0 ;	ZZ[173] = 0 ;
		ZZ[174] = 0 ;	ZZ[175] = 0 ;
		ZZ[176] = 0 ;	ZZ[177] = 0 ;
		ZZ[178] = 0 ;	ZZ[179] = 0 ;
		ZZ[180] = 0 ;	ZZ[181] = 0 ;
		ZZ[182] = 0 ;	ZZ[183] = 0 ;
		ZZ[184] = 0 ;	ZZ[185] = 0 ;
		ZZ[186] = 0 ;	ZZ[187] = 0 ;
		ZZ[188] = 0 ;	ZZ[189] = 0 ;
		ZZ[190] = 0 ;	ZZ[191] = 0 ;

		ZZ[192] = 1 ;	ZZ[193] = 0 ;
		ZZ[194] = 1 ;	ZZ[195] = 0 ;
		ZZ[196] = 0 ;	ZZ[197] = 1 ;
		ZZ[198] = 0 ;	ZZ[199] = 1 ;
		ZZ[200] = 1 ;	ZZ[201] = 0 ;
		ZZ[202] = 1 ;	ZZ[203] = 0 ;
		ZZ[204] = 0 ;	ZZ[205] = 1 ;
		ZZ[206] = 0 ;	ZZ[207] = 1 ;
		ZZ[208] = 0 ;	ZZ[209] = 0 ;
		ZZ[210] = 0 ;	ZZ[211] = 0 ;
		ZZ[212] = 1 ;	ZZ[213] = 0 ;
		ZZ[214] = 1 ;	ZZ[215] = 0 ;
		ZZ[216] = 0 ;	ZZ[217] = 0 ;
		ZZ[218] = 0 ;	ZZ[219] = 0 ;
		ZZ[220] = 1 ;	ZZ[221] = 0 ;
		ZZ[222] = 1 ;	ZZ[223] = 0 ;
		ZZ[224] = 1 ;	ZZ[225] = 0 ;
		ZZ[226] = 1 ;	ZZ[227] = 0 ;
		ZZ[228] = 0 ;	ZZ[229] = 1 ;
		ZZ[230] = 0 ;	ZZ[231] = 1 ;
		ZZ[232] = 1 ;	ZZ[233] = 0 ;
		ZZ[234] = 1 ;	ZZ[235] = 0 ;
		ZZ[236] = 0 ;	ZZ[237] = 1 ;
		ZZ[238] = 0 ;	ZZ[239] = 1 ;
		ZZ[240] = 1 ;	ZZ[241] = 0 ;
		ZZ[242] = 1 ;	ZZ[243] = 0 ;
		ZZ[244] = 0 ;	ZZ[245] = 1 ;
		ZZ[246] = 0 ;	ZZ[247] = 1 ;
		ZZ[248] = 1 ;	ZZ[249] = 0 ;
		ZZ[250] = 1 ;	ZZ[251] = 0 ;
		ZZ[252] = 0 ;	ZZ[253] = 1 ;
		ZZ[254] = 0 ;	ZZ[255] = 1 ;

		LUT[ 0] = 0 ;	LUT[ 1] = 1 ;
		LUT[ 2] = 1 ;	LUT[ 3] = 6 ;
		LUT[ 4] = 0 ;	LUT[ 5] = 1 ;
		LUT[ 6] = 1 ;	LUT[ 7] = 6 ;
		LUT[ 8] = 0 ;	LUT[ 9] = 1 ;
		LUT[10] = 1 ;	LUT[11] = 6 ;
		LUT[12] = 5 ;	LUT[13] = 2 ;
		LUT[14] = 2 ;	LUT[15] = 3 ;
		LUT[16] = 0 ;	LUT[17] = 7 ;
		LUT[18] = 1 ;	LUT[19] = 0 ;
		LUT[20] = 3 ;	LUT[21] = 2 ;
		LUT[22] = 4 ;	LUT[23] = 3 ;
		LUT[24] = 0 ;	LUT[25] = 7 ;
		LUT[26] = 1 ;	LUT[27] = 0 ;
		LUT[28] = 0 ;	LUT[29] = 7 ;
		LUT[30] = 1 ;	LUT[31] = 0 ;
}
