#include <stdio.h>

int lut_F0[64];
int lut_Fn[64];
int lut_OV[64];
int lut_Cn[64];
int lut_P[64];
int lut_G[64];

static void init_lut();

alu_test_logic(int s, int c, int a, int b) {
	int f0,f1,f2,f3,co,ov,fo;
	int ci;

	s &= 0x7;
	c &= 1;
	a &= 0xf;
	b &= 0xf;

	ci = c;

	if (s == 0) {
		fo = 0;
		ov = 1;
		co = 1;
	} else if (s == 1) {
		fo = b - a - !c;
		co = ! ( ( (fo & 0x10) >> 4 ) & 1 );
		fo &= 0xf;
		ov = 0;
	} else if (s == 2) {
		fo = a - b - !c;
		co = ! (( (fo & 0x10) >> 4 ) & 1);
		fo &= 0xf;
		ov = 0;
	} else if (s == 3) {
		fo = a + b + c;
		co = ( (fo & 0x10) >> 4 ) & 1;
		fo &= 0xf;
		ov = 0;
	} else if (s == 4) {
		fo = a ^ b;
		co = ov = 0;
	} else if (s == 5) {
		fo = a | b;
		fo &= 0xf;
		co = ov = 0;
	} else if (s == 6) {
		fo = a & b;
		fo &= 0xf;
		co = ov = 0;
	} else if (s == 7) { // preset
		fo = 0xf;
		fo &= 0xf;
		co = ov = 0;
	}

	printf("s %d(%s) ci %d a 0x%x b 0x%x =>  ov %d co %d f 0x%x\n"
		, s
		, (s == 0)?"Clear"
		 :(s == 1)?"B - A"
		 :(s == 2)?"A - B"
		 :(s == 3)?"A + B"
		 :(s == 4)?"A ^ B"
		 :(s == 5)?"A | B"
		 :(s == 6)?"A & B"
		 : "Preset"
		, ci, a, b, ov, co, fo);
}

alu_test(int s, int c, int a, int b) {
	int f0,f1,f2,f3,co,ov,fo;
	int ci;

	s &= 0x7;
	c &= 1;
	a &= 0xf;
	b &= 0xf;

	ci = c;

	f0 = lut_F0 [ (s << 3) | (c << 2) 
			| (((a >> 0) & 1) << 1)
			| (((b >> 0) & 1) << 0) ];
#if 0
	f1 = lut_Fn [ (s << 3) | (c << 2) 
			| (((a >> 1) & 1) << 1)
			| (((b >> 1) & 1) << 0) ];
	f2 = lut_Fn [ (s << 3) | (c << 2) 
			| (((a >> 2) & 1) << 1)
			| (((b >> 2) & 1) << 0) ];
	f3 = lut_Fn [ (s << 3) | (c << 2) 
			| (((a >> 3) & 1) << 1)
			| (((b >> 3) & 1) << 0) ];

#else
	c  = lut_Cn [ (s << 3) | (c << 2) 
			| (((a >> 0) & 1) << 1)
			| (((b >> 0) & 1) << 0) ];
	f1 = lut_F0 [ (s << 3) | (c << 2) 
			| (((a >> 1) & 1) << 1)
			| (((b >> 1) & 1) << 0) ];
	c  = lut_Cn [ (s << 3) | (c << 2) 
			| (((a >> 1) & 1) << 1)
			| (((b >> 1) & 1) << 0) ];
	f2 = lut_F0 [ (s << 3) | (c << 2) 
			| (((a >> 2) & 1) << 1)
			| (((b >> 2) & 1) << 0) ];
	c  = lut_Cn [ (s << 3) | (c << 2) 
			| (((a >> 2) & 1) << 1)
			| (((b >> 2) & 1) << 0) ];
	f3 = lut_F0 [ (s << 3) | (c << 2) 
			| (((a >> 3) & 1) << 1)
			| (((b >> 3) & 1) << 0) ];

#endif
	fo = (f3 << 3) | (f2 << 2) | (f1 << 1) | (f0 << 0);

	co = lut_Cn [ (s << 3) | (c << 2) 
			| (((a >> 3) & 1) << 1)
			| (((b >> 3) & 1) << 0) ];

	ov = lut_OV [ (s << 3) | (c << 2) 
			| (((a >> 3) & 1) << 1)
			| (((b >> 3) & 1) << 0) ];

	if (s >= 4) {
		co = ov = 0;
	}
	printf("s %d(%s) ci %d a 0x%x b 0x%x =>  ov %d co %d f 0x%x\n"
		, s
		, (s == 0)?"Clear"
		 :(s == 1)?"B - A"
		 :(s == 2)?"A - B"
		 :(s == 3)?"A + B"
		 :(s == 4)?"A ^ B"
		 :(s == 5)?"A | B"
		 :(s == 6)?"A & B"
		 : "Preset"
		, ci, a, b, ov, co, fo);
}

main() {
	int s,c,a,b;
	char buf[256];
	init_lut();

#if 0
	while (fgets(buf, 256, stdin)) {
		if (sscanf(buf, "%d %x %x %x\n",&s,&c,&a,&b) == 4) {
			alu_test(s, c, a, b);
		}
	}
#else
	for (s = 0; s < 8; s++) {
	    for (c=0; c<2; c++) {
		for (a=0; a<16; a++) {
		   for (b=0; b<16; b++) {
#if ( TEST == 2)
			alu_test(s, c, a, b);
#else
			alu_test_logic(s, c, a, b);
#endif
		   }
		}
	    }
	}
#endif
}

static void init_lut() {
		lut_F0[ 0] =    0;	lut_F0[ 1] =    0;
		lut_F0[ 2] =    0;	lut_F0[ 3] =    0;
		lut_F0[ 4] =    0;	lut_F0[ 5] =    0;
		lut_F0[ 6] =    0;	lut_F0[ 7] =    0;
		lut_F0[ 8] =    1;	lut_F0[ 9] =    0;
		lut_F0[10] =    0;	lut_F0[11] =    1;
		lut_F0[12] =    0;	lut_F0[13] =    1;
		lut_F0[14] =    1;	lut_F0[15] =    0;
		lut_F0[16] =    1;	lut_F0[17] =    0;
		lut_F0[18] =    0;	lut_F0[19] =    1;
		lut_F0[20] =    0;	lut_F0[21] =    1;
		lut_F0[22] =    1;	lut_F0[23] =    0;
		lut_F0[24] =    0;	lut_F0[25] =    1;
		lut_F0[26] =    1;	lut_F0[27] =    0;
		lut_F0[28] =    1;	lut_F0[29] =    0;
		lut_F0[30] =    0;	lut_F0[31] =    1;
		lut_F0[32] =    0;	lut_F0[33] =    1;
		lut_F0[34] =    1;	lut_F0[35] =    0;
		lut_F0[36] =    0;	lut_F0[37] =    1;
		lut_F0[38] =    1;	lut_F0[39] =    0;
		lut_F0[40] =    0;	lut_F0[41] =    1;
		lut_F0[42] =    1;	lut_F0[43] =    1;
		lut_F0[44] =    0;	lut_F0[45] =    1;
		lut_F0[46] =    1;	lut_F0[47] =    1;
		lut_F0[48] =    0;	lut_F0[49] =    0;
		lut_F0[50] =    0;	lut_F0[51] =    1;
		lut_F0[52] =    0;	lut_F0[53] =    0;
		lut_F0[54] =    0;	lut_F0[55] =    1;
		lut_F0[56] =    1;	lut_F0[57] =    1;
		lut_F0[58] =    1;	lut_F0[59] =    1;
		lut_F0[60] =    1;	lut_F0[61] =    1;
		lut_F0[62] =    1;	lut_F0[63] =    1;

		lut_Fn[ 0] =    0;	lut_Fn[ 1] =    0;
		lut_Fn[ 2] =    0;	lut_Fn[ 3] =    0;
		lut_Fn[ 4] =    0;	lut_Fn[ 5] =    0;
		lut_Fn[ 6] =    0;	lut_Fn[ 7] =    0;
		lut_Fn[ 8] =    1;	lut_Fn[ 9] =    1;
		lut_Fn[10] =    0;	lut_Fn[11] =    1;
		lut_Fn[12] =    0;	lut_Fn[13] =    1;
		lut_Fn[14] =    0;	lut_Fn[15] =    0;
		lut_Fn[16] =    1;	lut_Fn[17] =    0;
		lut_Fn[18] =    1;	lut_Fn[19] =    1;
		lut_Fn[20] =    0;	lut_Fn[21] =    0;
		lut_Fn[22] =    1;	lut_Fn[23] =    0;
		lut_Fn[24] =    0;	lut_Fn[25] =    1;
		lut_Fn[26] =    1;	lut_Fn[27] =    1;
		lut_Fn[28] =    0;	lut_Fn[29] =    0;
		lut_Fn[30] =    0;	lut_Fn[31] =    1;
		lut_Fn[32] =    0;	lut_Fn[33] =    1;
		lut_Fn[34] =    1;	lut_Fn[35] =    0;
		lut_Fn[36] =    0;	lut_Fn[37] =    1;
		lut_Fn[38] =    1;	lut_Fn[39] =    0;
		lut_Fn[40] =    0;	lut_Fn[41] =    1;
		lut_Fn[42] =    1;	lut_Fn[43] =    1;
		lut_Fn[44] =    0;	lut_Fn[45] =    1;
		lut_Fn[46] =    1;	lut_Fn[47] =    1;
		lut_Fn[48] =    0;	lut_Fn[49] =    0;
		lut_Fn[50] =    0;	lut_Fn[51] =    1;
		lut_Fn[52] =    0;	lut_Fn[53] =    0;
		lut_Fn[54] =    0;	lut_Fn[55] =    1;
		lut_Fn[56] =    1;	lut_Fn[57] =    1;
		lut_Fn[58] =    1;	lut_Fn[59] =    1;
		lut_Fn[60] =    1;	lut_Fn[61] =    1;
		lut_Fn[62] =    1;	lut_Fn[63] =    1;

		lut_OV[ 0] =    1;	lut_OV[ 1] =    1;
		lut_OV[ 2] =    1;	lut_OV[ 3] =    1;
		lut_OV[ 4] =    1;	lut_OV[ 5] =    1;
		lut_OV[ 6] =    1;	lut_OV[ 7] =    1;
		lut_OV[ 8] =    0;	lut_OV[ 9] =    0;
		lut_OV[10] =    0;	lut_OV[11] =    0;
		lut_OV[12] =    0;	lut_OV[13] =    0;
		lut_OV[14] =    0;	lut_OV[15] =    0;
		lut_OV[16] =    0;	lut_OV[17] =    0;
		lut_OV[18] =    0;	lut_OV[19] =    0;
		lut_OV[20] =    0;	lut_OV[21] =    0;
		lut_OV[22] =    0;	lut_OV[23] =    0;
		lut_OV[24] =    0;	lut_OV[25] =    0;
		lut_OV[26] =    0;	lut_OV[27] =    0;
		lut_OV[28] =    0;	lut_OV[29] =    0;
		lut_OV[30] =    0;	lut_OV[31] =    0;
		lut_OV[32] =    0;	lut_OV[33] =    0;
		lut_OV[34] =    0;	lut_OV[35] =    1;
		lut_OV[36] =    0;	lut_OV[37] =    0;
		lut_OV[38] =    1;	lut_OV[39] =    1;
		lut_OV[40] =    0;	lut_OV[41] =    0;
		lut_OV[42] =    0;	lut_OV[43] =    0;
		lut_OV[44] =    0;	lut_OV[45] =    0;
		lut_OV[46] =    0;	lut_OV[47] =    1;
		lut_OV[48] =    1;	lut_OV[49] =    0;
		lut_OV[50] =    1;	lut_OV[51] =    0;
		lut_OV[52] =    1;	lut_OV[53] =    0;
		lut_OV[54] =    1;	lut_OV[55] =    1;
		lut_OV[56] =    0;	lut_OV[57] =    0;
		lut_OV[58] =    0;	lut_OV[59] =    0;
		lut_OV[60] =    0;	lut_OV[61] =    0;
		lut_OV[62] =    0;	lut_OV[63] =    1;
	
		lut_Cn[ 0] =    1;	lut_Cn[ 1] =    1;
		lut_Cn[ 2] =    1;	lut_Cn[ 3] =    1;
		lut_Cn[ 4] =    1;	lut_Cn[ 5] =    1;
		lut_Cn[ 6] =    1;	lut_Cn[ 7] =    1;
		lut_Cn[ 8] =    0;	lut_Cn[ 9] =    1;
		lut_Cn[10] =    0;	lut_Cn[11] =    0;
		lut_Cn[12] =    1;	lut_Cn[13] =    1;
		lut_Cn[14] =    0;	lut_Cn[15] =    1;
		lut_Cn[16] =    0;	lut_Cn[17] =    0;
		lut_Cn[18] =    1;	lut_Cn[19] =    0;
		lut_Cn[20] =    1;	lut_Cn[21] =    0;
		lut_Cn[22] =    1;	lut_Cn[23] =    1;
		lut_Cn[24] =    0;	lut_Cn[25] =    0;
		lut_Cn[26] =    0;	lut_Cn[27] =    1;
		lut_Cn[28] =    0;	lut_Cn[29] =    1;
		lut_Cn[30] =    1;	lut_Cn[31] =    1;
		lut_Cn[32] =    0;	lut_Cn[33] =    0;
		lut_Cn[34] =    0;	lut_Cn[35] =    1;
		lut_Cn[36] =    0;	lut_Cn[37] =    0;
		lut_Cn[38] =    1;	lut_Cn[39] =    1;
		lut_Cn[40] =    0;	lut_Cn[41] =    0;
		lut_Cn[42] =    0;	lut_Cn[43] =    0;
		lut_Cn[44] =    0;	lut_Cn[45] =    0;
		lut_Cn[46] =    0;	lut_Cn[47] =    1;
		lut_Cn[48] =    1;	lut_Cn[49] =    0;
		lut_Cn[50] =    1;	lut_Cn[51] =    0;
		lut_Cn[52] =    1;	lut_Cn[53] =    0;
		lut_Cn[54] =    1;	lut_Cn[55] =    1;
		lut_Cn[56] =    0;	lut_Cn[57] =    0;
		lut_Cn[58] =    0;	lut_Cn[59] =    0;
		lut_Cn[60] =    0;	lut_Cn[61] =    0;
		lut_Cn[62] =    0;	lut_Cn[63] =    1;
	
		lut_G[ 0] =    0;	lut_G[ 1] =    0;
		lut_G[ 2] =    0;	lut_G[ 3] =    0;
		lut_G[ 4] =    0;	lut_G[ 5] =    0;
		lut_G[ 6] =    0;	lut_G[ 7] =    0;
		lut_G[ 8] =    1;	lut_G[ 9] =    0;
		lut_G[10] =    1;	lut_G[11] =    1;
		lut_G[12] =    1;	lut_G[13] =    0;
		lut_G[14] =    1;	lut_G[15] =    1;
		lut_G[16] =    1;	lut_G[17] =    1;
		lut_G[18] =    0;	lut_G[19] =    1;
		lut_G[20] =    1;	lut_G[21] =    1;
		lut_G[22] =    0;	lut_G[23] =    1;
		lut_G[24] =    1;	lut_G[25] =    1;
		lut_G[26] =    1;	lut_G[27] =    0;
		lut_G[28] =    1;	lut_G[29] =    1;
		lut_G[30] =    1;	lut_G[31] =    0;
		lut_G[32] =    1;	lut_G[33] =    1;
		lut_G[34] =    1;	lut_G[35] =    0;
		lut_G[36] =    1;	lut_G[37] =    1;
		lut_G[38] =    1;	lut_G[39] =    0;
		lut_G[40] =    1;	lut_G[41] =    1;
		lut_G[42] =    1;	lut_G[43] =    1;
		lut_G[44] =    1;	lut_G[45] =    1;
		lut_G[46] =    1;	lut_G[47] =    1;
		lut_G[48] =    0;	lut_G[49] =    1;
		lut_G[50] =    0;	lut_G[51] =    1;
		lut_G[52] =    0;	lut_G[53] =    1;
		lut_G[54] =    0;	lut_G[55] =    1;
		lut_G[56] =    1;	lut_G[57] =    1;
		lut_G[58] =    1;	lut_G[59] =    1;
		lut_G[60] =    1;	lut_G[61] =    1;
		lut_G[62] =    1;	lut_G[63] =    1;
	
		lut_P[ 0] =    0;	lut_P[ 1] =    0;
		lut_P[ 2] =    0;	lut_P[ 3] =    0;
		lut_P[ 4] =    0;	lut_P[ 5] =    0;
		lut_P[ 6] =    0;	lut_P[ 7] =    0;
		lut_P[ 8] =    0;	lut_P[ 9] =    0;
		lut_P[10] =    1;	lut_P[11] =    0;
		lut_P[12] =    0;	lut_P[13] =    0;
		lut_P[14] =    1;	lut_P[15] =    0;
		lut_P[16] =    0;	lut_P[17] =    1;
		lut_P[18] =    0;	lut_P[19] =    0;
		lut_P[20] =    0;	lut_P[21] =    1;
		lut_P[22] =    0;	lut_P[23] =    0;
		lut_P[24] =    1;	lut_P[25] =    0;
		lut_P[26] =    0;	lut_P[27] =    0;
		lut_P[28] =    1;	lut_P[29] =    0;
		lut_P[30] =    0;	lut_P[31] =    0;
		lut_P[32] =    1;	lut_P[33] =    1;
		lut_P[34] =    0;	lut_P[35] =    0;
		lut_P[36] =    1;	lut_P[37] =    1;
		lut_P[38] =    0;	lut_P[39] =    0;
		lut_P[40] =    1;	lut_P[41] =    1;
		lut_P[42] =    1;	lut_P[43] =    0;
		lut_P[44] =    1;	lut_P[45] =    1;
		lut_P[46] =    1;	lut_P[47] =    0;
		lut_P[48] =    0;	lut_P[49] =    1;
		lut_P[50] =    0;	lut_P[51] =    0;
		lut_P[52] =    0;	lut_P[53] =    1;
		lut_P[54] =    0;	lut_P[55] =    0;
		lut_P[56] =    1;	lut_P[57] =    1;
		lut_P[58] =    1;	lut_P[59] =    0;
		lut_P[60] =    1;	lut_P[61] =    1;
		lut_P[62] =    1;	lut_P[63] =    0;
}	
