// CLOCK options
// CLK is generated by GPR
`define USE_DMY_CLOCK

`define IOR_DRIVEN_CLK2X

// CORE definition
//`define SUPPORT_LDST32  // +13 - +24 slices  : not default
`define SUPPORT_LDD	  // reduced ver (31 >= disp >= 0) : default

`define USE_GPR_16	  // use shrinked version for GPR
//`define RAM_CLK_LATCH
//`define ROM_CLK_LATCH
//`define RAM_CLK_LOGIC
//`define ROM_CLK_LOGIC

//`define STALL_WB_CONFLICT_1
//  - STALL any WB inst + INDEX inst : not recomended
//`define STALL_WB_CONFLICT_2
//  - STALL LO8 WB inst + INDEX inst :  not recomended
//`define STALL_WB_CONFLICT_3
//  - STALL r26-r31 WB inst + INDEX X/Y/Z inst
//`define STALL_WB_CONFLICT_4
//  - STALL r26/r28/r30 WB inst + INDEX X/Y/Z inst  : gpr_16 only (+ 2slices)

`define STALL_WB_CONFLICT_3

// performance (Max CLK) tuning
//`define NEXTPC_TUNE	//
//`define EA_TUNE	// 

`define IOR_LARGE_MAPPER

// use tri-state bus (emulation for SP3)
//`define OUTPUT_MUX_TRI

// don't use OE_RAM / OE_RAM
`define OUTPUT_MUX_NONE

// mux by or IOR sub-modules
`define OUTPUT_MUX_OR

// GPR build options
`define GPR_INITCLR

// SRAM build options
`define SRAM_INITCLR

//`define USE_ALU	// OP2/OP3 moved to ALU
`define USE_ALU_MODULE	// OP2/OP3 moved to ALU (using module)
//`define ALU_Z_TUNE	// large
//`define ALU_Z_TUNE_2	// large and slow currently


//`define RTAVR_PORT_ESCALATION		// RTAVR is sub-module
`define IOR_PORT_ESCALATION		// IOR is sub-module

// top layer configuration
`define RTAVR_INCLUDE_IOR
`define RTAVR_INCLUDE_RAM
`define RTAVR_INCLUDE_ROM
`define RTAVR_INCLUDE_INTCONT

//`define PRC_WATCH		// (debug option)
//`define PRC_WATCH_WDR		// (debug option)

// IOR configuration
//`define IOR_HAVE_PORTA
//`define IOR_HAVE_PORTB
`define IOR_HAVE_PORTC
`define IOR_HAVE_SREG_SP
//`define FIXED_SPH	0	// fixed SPH (-19 slices)
`define IOR_SPHBITS	2	// SPH bits 1-8 (-15 slices)
`define IOR_HAVE_INT0
//`define IOR_HAVE_INT1
//`define IOR_HAVE_RAMWIN
//`define IOR_HAVE_RAMWIN_HA	// hi-addr
`define IOR_HAVE_NVM
`define IOR_HAVE_TIM0
//`define IOR_HAVE_TIM0_OC0A
//`define IOR_HAVE_TIM0_OC0B
`define IOR_HAVE_SPI
`define IOR_HAVE_USART
// `define IOR_HAVE_TWI 	// notyet

`ifdef IOR_HAVE_RAMWIN
`define RAM_HAVE_PORTA
`endif

// ROM configuration

// use rom_data.dat (using $readmemh) default
`define ROM_INCLUDE_DAT
// use rom_data.v
//`define ROM_INCLUDE_V

//`define ROM_SIZE 1024
`define ROM_SIZE 2048
//`define ROM_SIZE 4096

// PORT configuration
`define PORT_HAVE_PIN_WRITE
//`define PORT_WATCH		// (debug option)

// TIM0 configuration
//`define TIM0_EXPORT_PS	// using when other timer is used
`define FIXED_CS0	3	// Prescaler 1: 1/1 2: 1/8 3: 1/64
				//           4: 1/256 5: 1/1024
				//   stop : write 0 set: write other val
`define FIXED_WGM0	0	//
`define FIXED_COM0B	0	//
`define FIXED_COM0A	0	//
//`define FIXED_OCR0B	127	//
`define FIXED_OCR0A	128	//


// USART configuration
//`define USART_LOCAL_LB
`define FIXED_MPCM	0	// 0: 
`define FIXED_U2X	1	// prescaler option
`define FIXED_UMSEL	0	// 0: async 1:sync 3: spi master
`define FIXED_UPM	0	// parity 0: none 2: even 3: odd
`define FIXED_USBS	0	// stop-bit 0: st1 1: st2
`define FIXED_UCSZ	3	// 2: 7bit 3: 8bit 7: 9bit
`define FIXED_UDORD	0	// 0: LSB first 1: MSB first (only in spi)
`define FIXED_UCPHA	0	// clock phase 0: IN-SFT 1: SFT-IN (only in spi)
`define FIXED_UCPOL	0	// clock polarity 0: normal 1: reversed
//`define FIXED_UBRR	106	// boud parameter (Max 12bit) 19.2k @ 16.5 MHz
//`define FIXED_UBRR	28	// boud parameter (Max 12bit) 19.2k @  6 MHz
//`define FIXED_UBRR	25	// boud parameter (Max 12bit) 19.2k @  4 MHz
`define UBRR_BITS	8	// boud parameter (2 - 16)


// SPI configuration
//`define SPI_HAVE_WCOL
//`define SPI_HAVE_PSV_SS
`define FIXED_MSTR	1 	// 1: Master 0: Slave
`define FIXED_DORD	0 	// 0: MSB first 1: LSB first
`define FIXED_CPOL	0	// 0: Noraml SCK , 1: Reversed SCK
`define FIXED_CPHA	0	// 0:IN_ SFT order , 1: SFT_IN order
//`define FIXED_SPR	0	// 0: 1/2 CLK , 1: 1/4 CLK 2: 1/8 CLK
				// 3: 1/16 CLK , 4: 1/32 CLK 5,6: 1/64 CLK
				// 7: 1/128 CLK 

// 
`define INT0_vect_num            1
`define INT1_vect_num            2
//`define INT2_vect_num            3
//`define INT3_vect_num            4
`define TIM0_COMPA_vect_num     11
`define TIM0_COMPB_vect_num     12
`define TIM0_OVF_vect_num       13
`define USART_TX_vect_num       14
`define USART_UDRE_vect_num     15
`define TWI_SLAVE_vect_num      16
`define SPI_vect_num            17
`define USART_RX_vect_num       18

`define	 PORTA_ADDR  6'h00   // PINA 0x00 , DDRA, PORTA
`define	 PORTB_ADDR  6'h04   // PINB 0x04 , DDRB, PORTB
`define	 PORTC_ADDR  6'h1b   // PINC 0x1b , DDRC, PORTC
`define	 RAMWIN_ADDR 6'h1f   // RAMDR 0x1f , RAMAR 0x20
`define	 TIM0_ADDR   6'h15   // OCR0B 0x15 - TCCR0A 0x19
`define	 SREG_ADDR   6'h3f   // SREG 0x3f , SPH,SPL,CCP,RSRFR,MCUCR 0x3a
`define	 MCUCR_ADDR  6'h3a   // MCUCR 0x3a
`define	 GIFR_ADDR   6'h0b   // GIFR 0x0b , GIMSK 0x0c
`define	 TIFR_ADDR   6'h25   // TIFR 0x25 , TIMSK 0x26  
`define	 NVM_ADDR    6'h32   // NVMCSR 0x32 , NVMCMD 0x33  
`define	 USART_ADDR  6'h0e   // USART : (0x0e - 0x14 ADC space)
`define	 SPI_ADDR   6'h2e    // SPI : SPDR 0x2e, SPSR, SPCR
`define	 TWI_ADDR   6'h28    // TWI : TWSD 0x28, TWSAM,TWSA, TWSSRA

`define PORT_IGNORE_COND		(0)
`define PORT_IGNORE_OUTPUT_COND		(i == 21)

`define	 INT0_BIT  18     // PC2
`define	 INT1_BIT  10     // PB2
`define	 OC0A_BIT  16     // PC0
`define	 OC0B_BIT   5     // PA5
`define	 SS_BIT    16     // PC0
`define	 SCK_BIT   17     // PC1
`define	 MOSI_BIT  20     // PC4
`define	 MISO_BIT  18     // PC2
`define	 RX_BIT    21     // PC5
`define	 TX_BIT    22     // PC6
`define	 XCK_BIT   23     // PC7
`define	 SDA_BIT   20     // PC4
`define	 SCL_BIT   17     // PC1
