#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <util/delay.h>

#define bit_set(port,bit)       { port |= (1<<(bit));}
#define bit_clear(port,bit)     { port &= ~(1<<(bit));}
#define min(a,b)                ((a)<(b) ? (a):(b))

#define nop()   __asm__ volatile ("nop" )
#define wdr()   __asm__ volatile("wdr" )
#define sleep()   __asm__ volatile("sleep" )

void t_mul1a(int16_t in, int16_t *out, int8_t i, uint8_t b) {
	*out = (in / (16-i)) * b;
//	*out +=  0x2562;
	return;
}

void t_mul1b(int16_t in, int16_t *out) {
	*out = in  * 3;
//	*out +=  0x2562;
	return;
}

int32_t t_mul32(int32_t a, int32_t b) {
	return (a - 1) * ( b - 1 );
}

int16_t t_mul16(int16_t a, int16_t b) {
	return (a - 1) * ( b - 1 );
}
uint16_t t_mul16u(uint16_t a, uint16_t b) {
	return (a - 1) * ( b - 1 );
}
int32_t t_mul16_r32(int16_t a, int16_t b) {
	return (int32_t)(a - 1) * (int32_t)( b - 1 );
}
int32_t t_mul16u_r32(uint16_t a, uint16_t b) {
	return (int32_t)(a - 1) * (int32_t)( b - 1 );
}
uint16_t t_mod32(int32_t a, uint16_t b) {
	return a % b;
}
